import VueLiteLayer from './VueLiteLayer'
import defaultOptions from './utils/defaultOptions'
import './style/style.scss'
import i18n from './lang'
import globalUtils from './utils/globalUtils'
import { merge } from 'lodash-es'

VueLiteLayer.install = function (Vue, globalOptions) {
  // globalOptions = { ...defaultOptions, ...globalOptions }
  let mergeGlobalOptions = merge({}, defaultOptions, globalOptions)
  // globalOptions.area = { ...defaultOptions.area, ...globalOptions.area }
  Vue.prototype.$layer = {
    open(options) {
      // options = { ...globalOptions, ...options }
      // options.area = { ...globalOptions.area, ...options.area }
      let currentOptions = merge({}, mergeGlobalOptions, options)
      //判断是否可以多开
      if (!currentOptions.multiply && globalUtils.size() > 0) {
        return
      }
      const DynamicLayer = Vue.extend(VueLiteLayer)
      i18n.locale = currentOptions.locale || 'zh'
      const instance = new DynamicLayer({
        i18n,
        propsData: { ...currentOptions },
      }).$mount()
      // globalUtils.add(nanoid(), instance)
      if (currentOptions.appendElement === null) {
        document.body.appendChild(instance.$el)
      } else {
        currentOptions.appendElement.appendChild(instance.$el)
      }
    },
    close(instance) {
      globalUtils.close(instance)
    },
    closeAll() {
      globalUtils.closeAll()
    },
  }
}
export default VueLiteLayer
