const instances = new Map()
const globalUtils = {
  add(uuid, instance) {
    instances.set(uuid, instance)
  },
  size() {
    return instances.size
  },
  close(instance) {
    instance.close()
  },
  closeAll() {
    const that = this
    instances.forEach(function (value, key, map) {
      that.close(value)
      map.delete(key)
    })
  },
  remove(key) {
    instances.delete(key)
  },
  setTop(instance) {
    let maxZIndex = 0
    let maxIndexInstance = null
    let minZIndex = instance.zIndex
    instances.forEach(function (value) {
      if (maxIndexInstance === null || maxZIndex < value.zIndex) {
        maxIndexInstance = value
        maxZIndex = value.zIndex
      }
    })
    if (maxIndexInstance !== instance) {
      if (maxZIndex === minZIndex) {
        instance.zIndex = maxZIndex + 1
      } else {
        instance.zIndex = maxZIndex
      }
      maxIndexInstance.zIndex = minZIndex
    }
  },
}
export default globalUtils
